
DELIMITER $
CREATE TABLE Test (t CHAR(8))$
DROP TABLE Test$


DELIMITER ;
CREATE TABLE Test  (t CHAR(8));
CREATE TABLE IF NOT EXISTS Test (colonne INTEGER(38));
DESC Test;

CREATE TABLE Test  (t CHAR(8));
CREATE TEMPORARY TABLE Test2 (colonne DECIMAL(38));

DROP TABLE Test;
show tables;
desc Test2;

CREATE TABLE Test (colonne DECIMAL(38,8));
DROP TABLE Test;

CREATE TABLE 
Test 
(colonne 
DECIMAL(38,8)
);

DROP TABLE Test;
CREATE TABLE 
     -- nom de la table
Test(
     -- description
     COLONNE DECIMAL(38,8)
     )
-- fin, ne pas oublier le point-virgule.
;

DROP TABLE Test;
CREATE TABLE 
     -- nom de la table
Test( #dbut de la description
     COLONNE DECIMAL(38,8)
     )
-- fin, ne pas oublier le point-virgule.
;

DROP TABLE Test;
CREATE TABLE Test (
    /* une plus grande description
       des colonnes */
     COLONNE /* type : */ DECIMAL(38,8));

CREATE TABLE bdutil.Compagnie
 (comp    CHAR(4),
  nrue    INTEGER(3),
  rue     CHAR(20),
  ville   CHAR(15) DEFAULT 'Paris' COMMENT 'Par defaut : Paris',
  nomComp CHAR(15) NOT NULL);

desc bdutil.Compagnie;
DROP TABLE bdutil.Compagnie;

CREATE TABLE Compagnie
(comp CHAR(4), nrue INTEGER(3),
 rue CHAR(20), ville CHAR(15) DEFAULT 'Paris' COMMENT 'Par defaut : Paris',
 nomComp CHAR(15) NOT NULL,
 CONSTRAINT pk_Compagnie PRIMARY KEY(comp));

CREATE TABLE Pilote
(brevet CHAR(6), nom CHAR(15) NOT NULL,
 nbHVol DECIMAL(7,2), compa CHAR(4),
 CONSTRAINT pk_Pilote PRIMARY KEY(brevet),
 CONSTRAINT ck_nbHVol CHECK (nbHVol BETWEEN 0 AND 20000),
 CONSTRAINT un_nom UNIQUE (nom),
 CONSTRAINT fk_Pil_compa_Comp FOREIGN KEY (compa) REFERENCES Compagnie(comp));

SHOW CREATE TABLE Compagnie;
SHOW FULL COLUMNS FROM Compagnie;
SHOW CREATE TABLE Pilote;
SHOW FULL COLUMNS FROM Pilote;

-- mode auto commit!!! par dfaut (1)

-- dsactivation
SET AUTOCOMMIT = 0;

INSERT INTO Compagnie
	VALUES ('AF', 10, 'Gambetta', 'Paris', 'Air France');
INSERT INTO Compagnie
   VALUES ('SING', 7, 'Camparols', 'Singapour', 'Singapore AL');

INSERT INTO Pilote VALUES ('PL-1', 'Louise Ente', 450, 'AF');
INSERT INTO Pilote VALUES ('PL-2', 'Jules Ente', 900, 'AF');
INSERT INTO Pilote VALUES ('PL-3', 'Paul Soutou', 1000, 'SING');
INSERT INTO Pilote VALUES ('PL-4', NULL, 1000, 'SING');
INSERT INTO Pilote VALUES ('PL-4', 'pas nul', 1000, 'XXXX');
INSERT INTO Pilote VALUES ('PL-4', 'pas nul', 21000, 'AF');
rollback;

SELECT * FROM Compagnie;
SELECT * FROM Pilote;

SELECT CONSTRAINT_NAME, CONSTRAINT_TYPE,TABLE_NAME
	FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS ;

SELECT CONSTRAINT_NAME,TABLE_NAME,COLUMN_NAME 
	FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE ;

DROP TABLE Pilote;
DROP TABLE Compagnie;
DROP TABLE Test;

-- Types

-- caractres

CREATE TABLE tchar (f CHAR(4), v VARCHAR(4));
INSERT INTO tchar VALUES ('ab ', 'ab ');
SELECT * FROM tchar ;
SELECT CONCAT(f,'+'), CONCAT(v,'+') FROM tchar;
DROP TABLE tchar;

--

CREATE TABLE tbinary (fixe BINARY(4), variable VARBINARY(4));
INSERT INTO tbinary VALUES ('ab ', 'ab ');
SELECT * FROM tbinary ;
SELECT CONCAT(fixe,'+'), CONCAT(variable,'+') FROM tbinary ;
DROP TABLE tbinary;

--numriques

CREATE TABLE tnum (t TINYINT(4) UNSIGNED);
INSERT INTO tnum VALUES (255);
SELECT * FROM tnum ;
DROP TABLE tnum;

-- suppressions

CREATE TABLE Compagnie
(comp CHAR(4), nrue INTEGER(3),
 rue CHAR(20), ville CHAR(15) DEFAULT 'Paris' COMMENT 'Par defaut : Paris',
 nomComp CHAR(15) NOT NULL,
 CONSTRAINT pk_Compagnie PRIMARY KEY(comp));

CREATE TABLE Pilote
(brevet CHAR(6), nom CHAR(15) NOT NULL,
 nbHVol DECIMAL(7,2), compa CHAR(4),
 CONSTRAINT pk_Pilote PRIMARY KEY(brevet),
 CONSTRAINT ck_nbHVol CHECK (nbHVol BETWEEN 0 AND 20000),
 CONSTRAINT un_nom UNIQUE (nom),
 CONSTRAINT fk_Pil_compa_Comp FOREIGN KEY (compa) REFERENCES Compagnie(comp));

-- OK en 5.1 et 5.5

ALTER TABLE Pilote DROP FOREIGN KEY fk_Pil_compa_Comp;
DROP TABLE Compagnie;
DROP TABLE Pilote;

-- passe pas en 5.5 ni en 5.1

DROP TABLE Compagnie CASCADE;
DROP TABLE Pilote;

-- passe pas (normal) en 5.5 et 5.1

DROP TABLE Compagnie RESTRICT;
DROP TABLE Pilote RESTRICT;

-- OK pour 5.1 et 5.5

DROP TABLE Pilote;
DROP TABLE Compagnie;

-- index (recrer les tables) 

CREATE UNIQUE INDEX idx_Pilote_nom3
	USING BTREE
	ON Pilote (nom(3) DESC);
CREATE INDEX idx_Pilote_compa
	USING BTREE
	ON Pilote (compa);

--

DROP INDEX idx_Pilote_nom3 ON Pilote;
ALTER TABLE Pilote DROP FOREIGN KEY fk_Pil_compa_Comp;
DROP INDEX idx_Pilote_compa ON Pilote;
DROP TABLE Compagnie;
DROP TABLE Pilote;

-- ou

DROP TABLE Pilote RESTRICT;
DROP TABLE Compagnie RESTRICT;

--

CREATE TABLE tableMyISAM 
(
  col1 INT(11) AUTO_INCREMENT,
  col2 CHAR(60) ,
  PRIMARY KEY (col1)
) ENGINE=MyISAM;

CREATE TABLE tableINNODB
(
  col1 INT(11) AUTO_INCREMENT,
  col2 CHAR(60) ,
  PRIMARY KEY (col1)
) ENGINE=INNODB;

CREATE TABLE tableDefaut
(
  col1 INT(11) AUTO_INCREMENT,
  col2 CHAR(60) ,
  PRIMARY KEY (col1)
);

SHOW ENGINES;

SHOW TABLE STATUS;

DROP TABLE tableMyISAM ;
DROP TABLE tableINNODB;
DROP TABLE tableDefaut;