
DROP TABLE IF EXISTS Pratique;
DROP TABLE IF EXISTS Adherent ;
DROP TABLE IF EXISTS Sport;

CREATE TABLE Sport
 (spid      TINYINT UNSIGNED NOT NULL, 
  splibelle VARCHAR(20) NOT NULL);

CREATE TABLE Adherent 
 (adhid      SMALLINT UNSIGNED NOT NULL, 
  nom        VARCHAR(25) NOT NULL, 
  prenom     VARCHAR(30) NOT NULL, 
  civilite   VARCHAR(12) NOT NULL, 
  date_nais  DATE NOT NULL,
  tel        VARCHAR(15));

CREATE TABLE Pratique
  (adhid SMALLINT UNSIGNED NOT NULL, spid TINYINT UNSIGNED NOT NULL);

source C:\\Donnees\\dev\\mySQL\\insertions-base-sports.sql

/* inscrire 2 adherents  tous les sports */
/* fait dans le script de chargement */

ANALYZE NO_WRITE_TO_BINLOG TABLE 
        Adherent,Pratique,Sport;

SELECT COUNT(*) "Nombre de sports" FROM Sport s;
SELECT COUNT(*) "Nombre d'adherents" FROM Adherent a;
SELECT COUNT(*) "Nombre d'inscriptions" FROM Pratique p;

SELECT COUNT(DISTINCT(prenom)) "Nombre de prenoms distincts" FROM Adherent;
SELECT COUNT(DISTINCT(tel)) "Nombre de tel distincts" FROM Adherent;
SELECT COUNT(*) "Nombre de tel nuls" FROM Adherent WHERE tel IS NULL;

